
#setup of variables
S          = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
E          = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
I          = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
MILD       = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)   
HOSP_MILD  = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz) 
MILD_U     = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)              
MILD_D     = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)              
SEV        = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
HOSP       = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
NEW_DEM_IC = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
HOSP_IC    = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)  
HOSP_POST_IC = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz) 
TotHosp   = matrix(data = NA, nrow = 1, ncol = TimeHoriz)
FAT        = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
REC        = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)               
N          = matrix(data = NA, nrow = 1, ncol = TimeHoriz)                        

DeltaFAT   = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)
PrDeath    = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)
ASPop      = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)    
Regime     = matrix(data = NA, nrow = 5, ncol = TimeHoriz)
Logistic   =matrix(data= NA, nrow = Age_Groups, ncol = TimeHoriz)
PrAv       =matrix(data= NA, nrow=TimeHoriz, ncol=1)
Pworkplace =matrix(data= NA, nrow=TimeHoriz, ncol=1)
Pschool   =matrix(data= NA, nrow=TimeHoriz, ncol=1)
Pgrocery   =matrix(data= NA, nrow=TimeHoriz, ncol=1)
R          = list()
R_t=matrix(data= NA, nrow=TimeHoriz, ncol=1)
R_tmean=matrix(data= NA, nrow=TimeHoriz, ncol=1)
##Initial Conditions
InitExp = zeros(Age_Groups,1)
InitInf = NInfInit*FracPopSec 

N[1]           = NInit                                         
ASPop[,1]      = FracPopSec*N[1]        
S[,1]          = ASPop[,1] - InitExp               
E[,1]          = InitExp                          
I[,1]          = InitInf                          
MILD[,1]       = zeros(Age_Groups,1)              
MILD_D[,1]     = zeros(Age_Groups,1)                  
MILD_U[,1]     = zeros(Age_Groups,1)                  
SEV[,1]        = zeros(Age_Groups,1)              
FAT[,1]        = zeros(Age_Groups,1)            
HOSP[,1]       = zeros(Age_Groups,1)              
HOSP_MILD[,1]  = zeros(Age_Groups,1)     
NEW_DEM_IC[,1] = zeros(Age_Groups,1)              
HOSP_IC[,1]    = zeros(Age_Groups,1) 
HOSP_POST_IC[,1]   = zeros(Age_Groups,1) 
TotHosp[1] = 0
REC[,1]        = zeros(Age_Groups,1)            
DeltaFAT[,1]   = zeros(Age_Groups,1) 
##Difference equation system:
FactorDeltas = matrix(data = NA, nrow = Age_Groups, ncol = TimeHoriz)

########

T=TimeHoriz-1

for (t in 1:T) { 
  
  #Calculate the Regime period
    if(t<TimeStartLockD){
    Regime[,t] = c(1, 0, 0, 0,0)
  } else if(t >= TimeStartLockD && t< May4){
    Regime[,t] = c(0, 1, 0, 0,0)
  } else if(t >= May4 && t< Sept14){ 
    Regime[,t] = c(0, 0, 1, 0,0)                                                                                                                                                                                                                                                                                                                                                                                                                                   
  } else if(t >= Sept14 && t< Nov1){ 
    Regime[,t] = c(0, 0, 0, 1,0)
  } else if(t >= Nov1){ 
    Regime[,t] = c(0, 0, 0, 0,1)
  }
  
  Iso  = 0.923094281 *Tr_0
  work = 1.531124754 *Tr_0
  RH   = work*(1+0.18)  # Rzero in high risk
  RL   = work*(1-0.12)  # Rzero in low risk
  
 
  if(t <=8) {
     Pworkplace[t] = (Vbar*(1+TEMP*temp[t])  )/ (sum(DeltaFAT[,t]) + Vbar*(1+TEMP*temp[t]))
     Pgrocery[t]   = (Vbar*(1+TEMP*temp[t])  )/ (sum(DeltaFAT[,t]) + Vbar*(1+TEMP*temp[t]))
  }else if (t>=8 & t< Nov1){
     Pworkplace[t] = ((Vbar)*(1+TEMP*temp[t])     )/ (sum(sum(DeltaFAT)[(t-6):t])/7 + Vbar*(1+TEMP*temp[t]))
     Pgrocery[t]   = ((Vbar - LOCK*Regime[2,t] -PHASE2* Regime[3,t]-PHASE2*Regime[4,t]-LOCK*Regime[5,t])*(1+TEMP*temp[t])     )/ (sum(sum(DeltaFAT)[(t-6):t])/7 + Vbar*(1+TEMP*temp[t]))
  }else if (t>=Nov1){
  Pworkplace[t] = ((Vbar)*(1+TEMP*temp[t])                  )/ (meanDeaths  + Vbar*(1+TEMP*temp[t]))
  Pgrocery[t]   = ((Vbar -LOCK*Regime[5,t])*(1+TEMP*temp[t]))/ (meanDeaths  + Vbar*(1+TEMP*temp[t]))
  }
  Pschool[t] =  Regime[1,t]*Pworkplace[t] + (Regime[2,t] + Regime[3,t])*Pgrocery[t]+ (Regime[4,t] + Regime[5,t])*Pworkplace[t]
  P  = c(rep(Pschool[t], 2), alpha[,t]*Pworkplace[t] + (1-alpha[,t])*Pgrocery[t], rep(Pgrocery[t], 5), rep(Pgrocery[t], 2))
  PP = P%*%t(P) 

  # RZerWorkers for normal and lockdown
  RNormFrame       = Iso
  RZerWorkers      = rbind(cbind( RL*ones(L,L),   Tr_0*ones(L,L), Tr_0*ones(L,L)),
                          cbind( Tr_0*ones(L,L), RH*ones(L,L),   Tr_0*ones(L,L)),
                          cbind( Tr_0*ones(L,L), Tr_0*ones(L,L), Tr_0*ones(L,L)))
  
  alphaMax         = c(ones(2*L,1),zeros(L,1))
  ActiveMax        = alphaMax%*%t(alphaMax)
  RZerWorkersMax   = ActiveMax*RZerWorkers+(1-ActiveMax)*( Iso*ones(3*L,3*L))
  
  alphaMin         = c(0.6*ones(2*L,1), zeros(L,1))
  ActiveMin        = alphaMin%*%t(alphaMin)
  RZerWorkersMin   = ActiveMin*RZerWorkers+(1-ActiveMin)*( Iso*ones(3*L,3*L))
  
  ## RZerNormal and Lockdown as induced by an activity vector
  # Frame
  Frame            = ones(Age_Groups)
  Frame[3:17,3:17] = zeros(3*L)
  
  FrameNorm        = RNormFrame*Frame

  RZerNormal            = FrameNorm
  RZerNormal[3:17,3:17] = RZerWorkersMax
  RZerNormal[1,1]       = RH
  RZerNormal[2,2]       = RH
  RZerLock              = FrameNorm
  RZerLock[3:17,3:17]   = RZerWorkersMin
  RZerLock[1,1]         = Iso
  RZerLock[2,2]         = Iso
  
#####
#Rzero equivalent in normal conditions:    
if (t==1){
  region=c("_Lombardia","_Veneto")
    
   write.csv2(RZerNormal, paste(paste("Data/RZerNormal",region[Region],bio[Bio_Parm],sep = ""),".csv",sep = ""))
    
   #RZerLockEq  
    Rworkplace_eq = bm[68]*work * (((Vbar - LOCK )/  Vbar)^2) 
    Rtransit_eq   = bm[68]*Tr_0 * (((Vbar - LOCK )/  Vbar)^2) 
    Rgrocery_eq   = bm[68]*Iso  * (((Vbar - LOCK )/  Vbar)^2) 
    RZerWorkersEq = rbind(
      cbind( Rworkplace_eq*(1-0.12)*ones(L,L), Rtransit_eq*ones(L,L),            Rtransit_eq*ones(L,L)),
      cbind( Rtransit_eq*ones(L,L),            Rworkplace_eq*(1+0.18)*ones(L,L), Rtransit_eq*ones(L,L)),
      cbind( Rtransit_eq*ones(L,L),            Rtransit_eq*ones(L,L),            Rtransit_eq*ones(L,L)))
    RZerLockEq=Rgrocery_eq*Frame
    alphaMin         = c(0.6*ones(2*L,1), zeros(L,1))
    ActiveMin        = alphaMin%*%t(alphaMin)
    RZerWorkersMin_eq   = ActiveMin*RZerWorkersEq+(1-ActiveMin)*( Rgrocery_eq*ones(3*L,3*L))
    RZerLockEq[3:17,3:17]   = RZerWorkersMin_eq
      write.csv2(RZerLockEq, paste(paste("Data/RZerLockEq",region[Region],bio[Bio_Parm],sep = ""),".csv",sep = ""))
}
  
#Rzero equivalent for the 5 simulated policies:  
if (Policy==1|Policy==2|Policy==3|Policy==4|Policy==5){
  if (t==(TimeStartNewPolicy +1)){
    region=c("_Lombardia","_Veneto")
    policy=c("_1","_2","_3","_4","_5")
      
    Rworkplace_eq = bm[TimeStartNewPolicy +1]*work * (( Vbar        / Vbar)^2) 
    Rtransit_eq   = bm[TimeStartNewPolicy +1]*Tr_0 * (( Vbar        / Vbar)^2) 
    Rgrocery_eq   = bm[TimeStartNewPolicy +1]*Iso  * (((Vbar - LOCK)/ Vbar)^2) 
    
    RH_eq         = Rworkplace_eq*(1+0.18)  # Rzero in high risk
    RL_eq         = Rworkplace_eq*(1-0.12)  # Rzero in low risk
    
    RZerWorkers_eq = rbind(
      cbind( Rworkplace_eq*(1-0.12)*ones(L,L), Rtransit_eq*ones(L,L),            Rtransit_eq*ones(L,L)),
      cbind( Rtransit_eq*ones(L,L),            Rworkplace_eq*(1+0.18)*ones(L,L), Rtransit_eq*ones(L,L)),
      cbind( Rtransit_eq*ones(L,L),            Rtransit_eq*ones(L,L),            Rtransit_eq*ones(L,L)))
    
    RZerSepar_eq                              = Rgrocery_eq*ones(Age_Groups)
    RZerSepar_eq[1,1]                         = RH_eq  # School policy                       
    RZerSepar_eq[2,2]                         = RH_eq  # High School policy
    
    alphaExt_eq = c(pmax(alpha[,t],0.6*ones(2*L,1)), zeros(L,1))
    RZerSeparAct_eq            = RZerSepar_eq
    Active_eq                  = alphaExt_eq%*%t(alphaExt_eq)
    RZerWorkersAct_eq          = Active*RZerWorkers_eq+(1-Active)*(Rgrocery_eq*ones(3*L,3*L))
    RZerSeparAct_eq[3:17,3:17] = RZerWorkersAct_eq
    
    write.csv2(RZerSeparAct_eq, paste(paste("Data/RZerSeparAct_eq_bm_",bm_Sim,"_Tinf1_",Tinf1[TimeHoriz-1],region[Region],policy[Policy],bio[Bio_Parm], sep = ""),".csv",sep = ""))
  }}                                              
#####  
  
  ## Preparing the Policy prescription matrix
  # RZerSepar matrix: adjusts the frame, the RZerWorkers to be determined later, yielding RZerSeparAct
  RZerSepar                              = Iso*ones(Age_Groups)
  RZerSepar[1,1]                         = Regime[3,t]*Iso + Regime[4,t]*RH+Regime[5,t]*RH# School opened at Sept 14                    
  RZerSepar[2,2]                         = Regime[3,t]*Iso + Regime[4,t]*RH+Regime[5,t]*RH# High School opened at Sept 14
           
  
  # create RZerSeparAct matrix
  
  alphaExt = c(pmax(alpha[,t],0.6*ones(2*L,1)), zeros(L,1))
  RZerSeparAct            = RZerSepar
  Active                  = alphaExt%*%t(alphaExt)
  RZerWorkersAct          = Active*RZerWorkers+(1-Active)*(Iso*ones(3*L,3*L))
  RZerSeparAct[3:17,3:17] = RZerWorkersAct
  
  R[[t]] =   Regime[1,t]*RZerNormal+Regime[2,t]*RZerLock+(Regime[3,t]+Regime[4,t]+Regime[5,t])*RZerSeparAct
  R[[t]] = bm[t]*PP*R[[t]] 
  xi = I[,t]/N[t]
  FactorDeltas[,t] = sigmaInf*t(t(xi)%*%R[[t]])
  R_t[t]=t(FracPopSec)%*%eye(Age_Groups)%*%t(t(S[,t]/N[t])%*%R[[t]])
  
  #Next period variables
  S[,t+1]          = S[,t] - S[,t]*eye(Age_Groups)%*%FactorDeltas[,t]
  E[,t+1]          = E[,t] + S[,t]*eye(Age_Groups)%*%FactorDeltas[,t] - sigmaInc*E[,t]
  I[,t+1]          = I[,t] + sigmaInc*E[,t]  - (1-delta[t,1])*sigmaInf*I[,t]-delta[t,1]*sigmaInfTest[t]*I[,t]
  
  MILD_U[,t+1]       =MILD_U[,t] + PrMild*(1-delta[t,1])*sigmaInf*I[,t] - sigmaSrecU*MILD_U[,t] - PrM2SevU*sigmaSHospU*MILD_U[,t]
  MILD_D[,t+1]       =MILD_D[,t] + PrMild*delta[t,1]*sigmaInfTest[t]*I[,t] - sigmaSrecD*MILD_D[,t] - PrM2SevD*sigmaSHospD*MILD_D[,t]  
  
  SEV[,t+1]       = SEV[,t]  +  (1-PrMild)*((1-delta[t,1])*sigmaInf*I[,t]+delta[t,1]*sigmaInfTest[t]*I[,t])- sigmaSHosp*SEV[,t]  
  HOSP[,t+1]      =HOSP[,t] + sigmaSHosp*SEV[,t]-PrIC*sigmaHospIC*HOSP[,t] -(1-PrIC)*sigmaShdSHosp*HOSP[,t] 
  HOSP_MILD[,t+1] =HOSP_MILD[,t]  + PrM2SevD*sigmaSHospU*MILD_D[,t] + PrM2SevU*sigmaSHospD*MILD_U[,t] -sigmaShdSHosp*HOSP_MILD[,t] 
  
  Logistic[,t+1]     = 1/(1+exp(-k_0*((sum(HOSP_MILD[,t+1]+HOSP[,t+1])) -k_1))) ###################
  PrDeath[,t+1]      = PrFat/((1-PrMild)*PrIC) + (1-(PrFat/((1-PrMild)*PrIC))) * Logistic[,t+1]
  
  if(Bio_Parm=="CDC_mean"){PrDeath[1:2,t+1]=0}
  
  NEW_DEM_IC[,t+1]   = PrIC*sigmaHospIC*HOSP[,t]
  PrAv [t+1]  = min(1, (ICC[t+1]-sum(HOSP_IC[,t]))/sum(NEW_DEM_IC[,t+1]) )
   
  HOSP_IC[,t+1] = HOSP_IC[,t] + PrAv[t+1]*NEW_DEM_IC[,t+1] - PrDeath[,t+1]*sigmaSdHospIc*HOSP_IC[,t] - (1-PrDeath[,t+1])*sigmaShdHospIc*HOSP_IC[,t]
  HOSP_POST_IC[,t+1] = HOSP_POST_IC[,t] + (1-PrDeath[,t+1])*sigmaShdHospIc*HOSP_IC[,t] - sigmaIcRec*HOSP_POST_IC[,t]
  FAT[,t+1]        = FAT[,t]  + (1-PrAv[t+1])*NEW_DEM_IC[,t+1] + PrDeath[,t+1]*sigmaSdHospIc*HOSP_IC[,t] 
  REC[,t+1]        = REC[,t]  + sigmaIcRec*HOSP_POST_IC[,t] + (1-PrIC)*sigmaShdSHosp*HOSP[,t] + sigmaSrecU*MILD_U[,t] + sigmaSrecD*MILD_D[,t] + sigmaShdSHosp*HOSP_MILD[,t] 
  
  #fatalities counter
  DeltaFAT[,t+1]   = FAT[,t+1] -FAT[,t]
  N[t+1]              = N[t]          - sum(DeltaFAT[,t+1])
  TotHosp[t+1] = sum(HOSP[1:Age_Groups,t+1]+HOSP_IC[1:Age_Groups,t+1]+(1-PrAv[t+1])*NEW_DEM_IC[,t+1]+HOSP_MILD[1:Age_Groups,t+1] )#+ HOSP_POST_IC[1:Age_Groups,t+1])
}

##Producing outcome
TotFAT = sum(FAT)
TotalDead = TotFAT[length(TotFAT)]
TotalDeadYr = TotFAT[TimeHoriz]-TotFAT[TimeStartNewPolicy-1]
GDPLoss   = LabShare%*%(t(ones(2*L,1))%*%FracPopSec[3:12] - t(alpha[,TimeStartNewPolicy])%*%FracPopSec[3:12])/(t(ones(2*L,1))%*%FracPopSec[3:12])

TotI = sum(I)
TotS = sum(S)
TotE = sum(E)
TotRec = sum(REC)

TotSEV = sum(SEV)
TotDeltaFAT = sum(DeltaFAT[1:Age_Groups,])

Dem_ICU=sum(NEW_DEM_IC+HOSP_IC)


ICCTR          = t(ICC)
CDexaLOSS      = GDPLoss

#END

